// tourists - slow solution 1
//O( m * (q + n) )

#include <bits/stdc++.h>
using namespace std;

const int lim = 2003;

vector<int> sc[lim];
int dist[lim][lim];

long long where[lim], val[lim];

void dfs(int w, int f, int sw, int l = 0)
{
    dist[w][sw] = l;
    for (auto i : sc[w])
    {
        if (i == f)
            continue;
        dfs(i, w, sw, l + 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    int n, m, q;
    cin >> n >> m >> q;
    for (int i = 1; i <= m; i++)
        cin >> where[i];
    for (int i = 1; i < n; i++)
    {
        int a, b;
        cin >> a >> b;
        sc[a].push_back(b);
        sc[b].push_back(a);
    }
    for (int i = 1; i <= n; i++)
        dfs(i, -1, i);
    while (q--)
    {
        string queryType;
        cin >> queryType;
        int a, b, c;
        if (queryType == "event")
        {
            cin >> a >> b;
            for (int i = 1; i <= m; i++)
                if (where[i] == a)
                    val[i] += b;
        }
        else if (queryType == "question")
        {
            cin >> a;
            cout << val[a] << '\n';
        }
        else if (queryType == "travel")
        {
            cin >> a >> b >> c;
            for (int i = a; i <= b; i++)
            {
                val[i] -= dist[where[i]][c];
                where[i] = c;
            }
        }
    }
}